<?php
/**
 * @package flash-show-and-hide-box
 */
/*
Plugin Name: Flash Show And Hide Box
Plugin URI: http://litefeel.com/flash-show-and-hide-box/
Description: Flash Show And Hide Box lets we very convenient embed flash, and control it show and hide.
Version: 1.1.1
Author: lite3
Author URI: http://litefeel.com/
License: GPLv2 or later
*/

/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, lite3@qq.com.
*/

/* options */
/* ------------------------------------------------------------ */
class FlashShowAndHideBoxOptions {
	
	function getDefalutOptions(){
		$options = array();
		$options['load_jquery']		= true;
		$options['load_swfobject']	= true;
		$options['load_showflashlib']	= true;
		$options['flash_hiding_state_text']	= __('Clike To Show Flash', 'flashshowandhidebox');
		$options['flash_showing_state_text']	= __('Clike To Hide Flash', 'flashshowandhidebox');
		return $options;
	}
	
	function getOptions() {
		$options = get_option('flashshowandhidebox_options');
		if (!is_array($options)) {
			$options = FlashShowAndHideBoxOptions::getDefalutOptions();
			
			update_option('flashshowandhidebox_options', $options);
		}
		return $options;
	}

	function add() {
		if(isset($_POST['flashshowandhidebox_save'])) {
			$options = FlashShowAndHideBoxOptions::getOptions();

			// load_jquery
			if(!$_POST['load_jquery']) {
				$options['load_jquery'] = (bool)false;
			} else {
				$options['load_jquery'] = (bool)true;
			}
			// load_swfobject
			if(!$_POST['load_swfobject']) {
				$options['load_swfobject'] = (bool)false;
			} else {
				$options['load_swfobject'] = (bool)true;
			}
			// load_showflashlib
			if(!$_POST['load_showflashlib']) {
				$options['load_showflashlib'] = (bool)false;
			} else {
				$options['load_showflashlib'] = (bool)true;
			}
			// flash_showing_state_text
			if(!$_POST['flash_showing_state_text']) {
				$options['flash_showing_state_text'] = '';
			} else {
				$options['flash_showing_state_text'] = (string)$_POST['flash_showing_state_text'];
			}
			// flash_hiding_state_text
			if(!$_POST['flash_hiding_state_text']) {
				$options['flash_hiding_state_text'] = '';
			} else {
				$options['flash_hiding_state_text'] = (string)$_POST['flash_hiding_state_text'];
			}
			
			update_js_file($options);
			update_option('flashshowandhidebox_options', $options);

		} else if(isset($_POST['flashshowandhidebox_reset'])) {
			$options = FlashShowAndHideBoxOptions::getDefalutOptions();
			update_js_file($options);
			update_option('flashshowandhidebox_options', $options);
		}else{
			FlashShowAndHideBoxOptions::getOptions();
		}

		add_options_page('Flash Show And Hide Box Options', 'Flash Show And Hide Box Options', 10, basename(__FILE__), array('FlashShowAndHideBoxOptions', 'display'));
	}

	function display() {
		$options = FlashShowAndHideBoxOptions::getOptions();
?>

<div class="wrap">
	<div class="icon32" id="icon-options-general"><br /></div>
	<h2><?php _e('Flash Show And Hide Box Options', 'flashshowandhidebox'); ?></h2>

	<div id="poststuff" class="has-right-sidebar">
		<div class="inner-sidebar">
			<div id="donate" class="postbox" style="border:2px solid #080;">
				<h3 class="hndle" style="color:#080;cursor:default;"><?php _e('Donation', 'flashshowandhidebox'); ?></h3>
				<div class="inside">
					<p><?php _e('If you like this plugin, please donate to support development and maintenance!', 'flashshowandhidebox'); ?>
					<br /><br /><strong><a href="https://me.alipay.com/lite3" target="_blank"><?php _e('Donate by alipay', 'flashshowandhidebox'); ?></a></strong><style>#donate form{display:none;}</style>
					</p>
				</div>
			</div>

			<div class="postbox">
				<h3 class="hndle" style="cursor:default;"><?php _e('About Author', 'flashshowandhidebox'); ?></h3>
				<div class="inside">
					<ul>
						<li><a href="http://www.litefeel.com/" target="_blank"><?php _e('Author Blog', 'flashshowandhidebox'); ?></a></li>
						<li><a href="http://www.litefeel.com/plugins/" target="_blank"><?php _e('More Plugins', 'flashshowandhidebox'); ?></a></li>
					</ul>
				</div>					
			</div>
		</div>

		<div id="post-body">
			<div id="post-body-content">

<form action="#" method="POST" enctype="multipart/form-data" name="flashshowandhidebox_form">
		<table class="form-table">
			<tbody>
				<tr valign="top">
					<th scope="row"><?php _e('jQurey Library', 'flashshowandhidebox'); ?></th>
					<td>
						<label>
							<input name="load_jquery" type="checkbox" <?php if($options['load_jquery']) echo 'checked="checked"'; ?> />
							 <?php _e('Load jQuery library that is supported by WordPress. If you already loaded jQuery at head, then do not select this option.', 'flashshowandhidebox'); ?>
						</label>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><?php _e('SWFObject Library', 'flashshowandhidebox'); ?></th>
					<td>
						<label>
							<input name="load_swfobject" type="checkbox" <?php if($options['load_swfobject']) echo 'checked="checked"'; ?> />
							 <?php _e('Load SWFObject library that is supported by WordPress. If you already loaded SWFObject at head, then do not select this option.', 'flashshowandhidebox'); ?>
						</label>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><?php _e('Flash Show And Hide Box Library', 'flashshowandhidebox'); ?></th>
					<td>
						<label>
							<input name="load_showflashlib" type="checkbox" <?php if($options['load_showflashlib']) echo 'checked="checked"'; ?> />
							 <?php _e('Load Flash Show And Hide Box library. If you already copy the showflash.js file for this plugin to other js file for head, then do not select this option.', 'flashshowandhidebox'); ?>
						</label>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><?php _e('The Text when flash is showing', 'flashshowandhidebox'); ?></th>
					<td>
						<label>
							<input name="flash_showing_state_text" type="input" value="<?php echo $options['flash_showing_state_text']; ?>" style="width:400px;"/>
						</label>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><?php _e('The Text when flash is hiding', 'flashshowandhidebox'); ?></th>
					<td>
						<label>
							<input name="flash_hiding_state_text" type="input" value="<?php echo $options['flash_hiding_state_text']; ?>" style="width:400px;"/>
						</label>
					</td>
				</tr>
			</tbody>
		</table>

		<p class="submit">
		<input class="button-primary" type="submit" name="flashshowandhidebox_save" value="<?php _e('Update Options', 'flashshowandhidebox'); ?>" />
		<input class="button-primary" type="submit" name="flashshowandhidebox_reset" value="<?php _e('Reset Settings to Defaults', 'flashshowandhidebox'); ?>" />
		</p>
</form>
			</div>
		</div>
	</div>
</div>

<?php
	}
}

add_action('admin_menu', array('FlashShowAndHideBoxOptions', 'add'));


load_plugin_textdomain( 'flashshowandhidebox', false, dirname( plugin_basename( __FILE__ ) ) . '/languages/');

add_action('init', 'flash_show_and_hide_box_init');
function flash_show_and_hide_box_init(){
	$options = get_option('flashshowandhidebox_options');
	$js_path = dirname(__FILE__). '/js/showflash.js';
	$m_time = -1;
	if(file_exists($js_path)){
		$m_time = filemtime($js_path);
	}
	$m_time .= '1.1.1';
	if($options['js_modify_time'] !== $m_time){
		update_js_file($options);
		update_option('flashshowandhidebox_options', $options);
	}
	
	flash_show_and_hide_box_load_staitc($options);
}

function flash_show_and_hide_box_load_staitc(&$options){
	//$options = get_option('flashshowandhidebox_options');
	if($options['load_jquery']){
		wp_enqueue_script('jquery');
	}
	if($options['load_swfobject']){
		wp_enqueue_script('swfobject');
	}
	if($options['load_showflashlib']){
		wp_enqueue_script('showFlashLib',  plugins_url('js/showflash.js', __FILE__), false, $options['js_modify_time']);
	}
}

function update_js_file(&$options){
	$flash_showing_state_text = $options['flash_showing_state_text'];
	$flash_hiding_state_text = $options['flash_hiding_state_text'];
	
	
	$js='var showFlashLib=function($){
		var swfs={};var lib={};
		lib.showFlash=function(id){
			var o=swfs[id];if(!o){return;}
			swfobject.embedSWF(o.swf,id,o.w,o.h,o.v,"' . WP_PLUGIN_URL . '/flash-show-and-hide-box/swf/expressInstall.swf",o.vars,o.par,o.att);
			$("#"+id+"_show").css({display:"none"});$("#"+id+"_hide").css({display:"block"});
		};
		lib.hideFlash=function(id){
			var o = swfs[id];if(!o){return;}
			var node = null;var pos = null;
			if($("#"+id).next()!==null){pos = "next";node = $("#"+id).next();}
			else if($("#"+id).prev()!==null){pos="prev";node=$("#"+id).prev();}
			else if($("#"+id).parent()!==null){pos="parent";node=$("#"+id).parent();}
			swfobject.removeSWF(id);
			$("#"+id+"_show").css({display:"block"});$("#"+id+"_hide").css({display:"none"});
			var txt=\'<div id="\'+id+\'"></div>\';
			if("next"===pos){node.before(txt);}
			else if("prev"===pos){node.after(txt);}
			else if("parent"===pos){node.append(txt);}
		};
		lib.initBox=function(src,id,w,h,v,vars,par,att){
			var html = \'<div style="cursor:pointer;text-align:center;display:black;"><p id="\'+id+\'_show" style=""><img src="' . WP_PLUGIN_URL . '/flash-show-and-hide-box/img/flash_icon.gif" alt="' . $flash_hiding_state_text .'" title="' . $flash_hiding_state_text .'"></img><br/>' . $flash_hiding_state_text .'</p>\';
			html += \'<p id="\'+id+\'_hide" style=""><img src="' . WP_PLUGIN_URL . '/flash-show-and-hide-box/img/flash_icon.gif" alt="' . $flash_showing_state_text .'" title="' . $flash_showing_state_text .'"></img><br/>' . $flash_showing_state_text .'</p></div>\';
			swfs[id] = {swf:src,id:id,w:w,h:h,v:v,vars:vars,par:par,att:att};
			$("#"+id).before(html);
			$("#"+id).css({display:"none"});
			$("#"+id+"_show").css({display:"block"});$("#"+id+"_hide").css({display:"none"});
			$("#"+id+"_show").click(function(){showFlashLib.showFlash(id);});
			$("#"+id+"_hide").click(function(){showFlashLib.hideFlash(id);});
		};
		lib.createBox=function(src,w,h,v,vars,par,att){
			var id="showFlashBox_"+Math.floor(Math.random()*10000);
			var html=\'<div id="\'+id+\'"></div>\';
			document.writeln(html);
			showFlashLib.initBox(src,id,w,h,v,vars,par,att);
		};
		return lib;
	}(jQuery);';
	
	
	
	
	
	
	
	
	
	//$js='/* ShowFlashLib */
/*var ShowFlashLib=function(){};
ShowFlashLib.prototype.swfs = {};
ShowFlashLib.prototype.showFlash=function(id){
var o = this.swfs[id];
if(!o){return;};swfobject.embedSWF(o.swf, id, o.w, o.h, o.v, "' . WP_PLUGIN_URL . '/flash-show-and-hide-box/swf/expressInstall.swf", o.vars, o.par, o.att);
jQuery("#"+id+"_show").css({display:"none"});jQuery("#"+id+"_hide").css({display:"block"});
};
ShowFlashLib.prototype.hideFlash=function(id){
var o = this.swfs[id];
if(!o){return;};var nod = null;var pos = null;
if(jQuery("#"+id).next() != null){
pos = "next";nod = jQuery("#"+id).next();
}else if(jQuery("#"+id).prev() != null){
pos = "prev";nod = jQuery("#"+id).prev();
}else if(jQuery("#"+id).parent()!=null){
pos = "parent";nod=jQuery("#"+id).parent();
}
swfobject.removeSWF(id);jQuery("#"+id+"_show").css({display:"block"});jQuery("#"+id+"_hide").css({display:"none"});
var txt=\'<div id="\'+id+\'"></div>\';
if("next"==pos){nod.before(txt);}
else if("prev"==pos){nod.after(txt);}
else if("parent"==pos){nod.append(txt);}
};
ShowFlashLib.prototype.initBox=function(src, objElemIdStr, w, h, v, vars, parObj, attObj){
var html = \'<div style="cursor:pointer;text-align:center;display:black;"><p id="\'+objElemIdStr+\'_show" style=""><img src="' . WP_PLUGIN_URL . '/flash-show-and-hide-box/img/flash_icon.gif" alt="' . $flash_hiding_state_text .'" title="' . $flash_hiding_state_text .'"></img><br/>' . $flash_hiding_state_text .'</p>\';
html += \'<p id="\'+objElemIdStr+\'_hide" style=""><img src="' . WP_PLUGIN_URL . '/flash-show-and-hide-box/img/flash_icon.gif" alt="' . $flash_showing_state_text .'" title="' . $flash_showing_state_text .'"></img><br/>' . $flash_showing_state_text .'</p></div>\';
ShowFlashLib.prototype.swfs[objElemIdStr] = {swf:src,id:objElemIdStr,w:w,h:h,v:v,vars:vars,par:parObj,att:attObj};
jQuery("#"+objElemIdStr).before(html);
jQuery("#"+objElemIdStr).css({display:"none"});
jQuery("#"+objElemIdStr+"_show").css({display:"block"});jQuery("#"+objElemIdStr+"_hide").css({display:"none"});
jQuery("#"+objElemIdStr+"_show").click(function(){showFlashLib.showFlash(objElemIdStr);});
jQuery("#"+objElemIdStr+"_hide").click(function(){showFlashLib.hideFlash(objElemIdStr);});
};
ShowFlashLib.prototype.createBox=function(src, w, h, v, vars, parObj, attObj){
var id="showFlashBox_"+Math.floor(Math.random()*10000);
var html=\'<div id="\'+id+\'"></div>\';
document.writeln(html);
showFlashLib.initBox(src,id,w,h,v,vars,parObj,attObj);
};
var showFlashLib = new ShowFlashLib();';*/

$js_path = dirname(__FILE__). '/js/showflash.js';
file_put_contents($js_path, $js);
$m_time = filemtime($js_path) . '1.1.1';
$options['js_modify_time'] = $m_time;
}

?>